<template>
  <div>
    <v-row dense justify="center">
      <v-dialog v-model="replaceDialog" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <span class="text-h5">{{ $sock.t("FindAndReplace") }}</span>
          </v-card-title>
          <v-card-text>
            <v-text-field
              v-model="find"
              :label="$sock.t('Find')"
              required
            ></v-text-field>

            <v-text-field
              v-model="replace"
              :label="$sock.t('Replace')"
              required
            ></v-text-field>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="blue darken-1" text @click="replaceDialog = false">{{
              $sock.t("Cancel")
            }}</v-btn>
            <v-btn color="blue darken-1" text @click="doReplace()">{{
              $sock.t("OK")
            }}</v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-row>
    <v-row v-if="formState.ready" dense>
      <v-col>
        <v-form ref="form">
          <v-row dense>
            <gz-error :error-box-message="formState.errorBoxMessage"></gz-error>
            <v-col v-if="obj.stock && rights.change" cols="12">
              <span class="text-h4 warning--text mr-6">{{
                $sock.t("ReadOnly")
              }}</span>
              <v-btn :loading="duplicating" @click="duplicate()">
                <v-icon left>$sockiClone</v-icon> {{ $sock.t("Duplicate") }}
              </v-btn>
            </v-col>
            <v-col cols="12" sm="6" lg="4" xl="3">
              <v-text-field
                ref="name"
                v-model="obj.name"
                dense
                :readonly="formState.readOnly"
                :label="$sock.t('Name')"
                :rules="[form().required(this, 'name')]"
                :error-messages="form().serverErrors(this, 'name')"
                data-cy="name"
                @input="fieldValueChanged('name')"
              ></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" lg="4" xl="3">
              <v-checkbox
                ref="cjkIndex"
                v-model="obj.cjkIndex"
                dense
                :readonly="formState.readOnly"
                :label="$sock.t('GlobalCJKIndex')"
                :hint="$sock.t('GlobalCJKIndexDescription')"
                :persistent-hint="true"
                :error-messages="form().serverErrors(this, 'cjkIndex')"
                @change="fieldValueChanged('cjkIndex')"
              ></v-checkbox>
            </v-col>
            <!-- ----------------------- -->
            <v-col cols="12">
              <v-card>
                <v-card-title>
                  <v-text-field
                    v-model="search"
                    dense
                    append-icon="$sockiSearch"
                    :label="$sock.t('Search')"
                    single-line
                    hide-details
                  ></v-text-field>
                </v-card-title>
                <v-data-table
                  dense
                  :headers="[
                    {
                      text: $sock.t('TranslationKey'),
                      align: 'start',
                      value: 'key'
                    },
                    {
                      text: $sock.t('TranslationDisplayText'),
                      value: 'display'
                    }
                  ]"
                  :items="obj.translationItems"
                  :footer-props="{
                    itemsPerPageOptions: [5, 10, 25, 50, 100],
                    itemsPerPageText: $sock.t('RowsPerPage'),
                    pageText: $sock.t('PageOfPageText')
                  }"
                  :header-props="{ sortByText: $sock.t('Sort') }"
                  :search="search"
                  :no-data-text="$sock.t('NoData')"
                  :options="{ sortBy: ['key'] }"
                  must-sort
                >
                  <template
                    v-if="!formState.readOnly"
                    v-slot:[`item.display`]="props"
                  >
                    <v-edit-dialog
                      large
                      :cancel-text="$sock.t('Cancel')"
                      :save-text="$sock.t('OK')"
                      @save="saveItem()"
                      @open="openEditDialog(props.item)"
                    >
                      {{ props.item.display }}
                      <template v-slot:input>
                        <v-text-field
                          v-model="editText"
                          dense
                          single-line
                        ></v-text-field>
                      </template>
                    </v-edit-dialog>
                  </template>
                </v-data-table>
              </v-card>
            </v-col>
            <!-- ------------------- -->
          </v-row>
        </v-form>
      </v-col>
    </v-row>
    <v-overlay :value="!formState.ready || formState.loading">
      <v-progress-circular indeterminate :size="64" />
    </v-overlay>
  </div>
</template>
<script>
const FORM_KEY = "translation-edit";
const API_BASE_URL = "translation/";
const FORM_CUSTOM_TEMPLATE_KEY = "Translation";

export default {
  components: {},
  data() {
    return {
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      search: "",
      find: "",
      replace: "",
      replaceDialog: false,
      editingActiveTranslation: false,
      duplicating: false,
      obj: {},
      formState: {
        ready: false,
        dirty: false,
        valid: true,
        readOnly: false,
        loading: true,
        errorBoxMessage: null,
        appError: null,
        serverError: {}
      },
      rights: window.$gz.role.defaultRightsObject(),
      sockType: window.$gz.type.Translation,
      editItem: {},
      editText: ""
    };
  },
  computed: {
    canSave: function() {
      return this.formState.valid && this.formState.dirty;
    }
  },
  watch: {
    formState: {
      handler: function(val) {
        if (this.formState.loading) {
          return;
        }

        if (val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":save");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":save");
        }

        if (!val.dirty && val.valid) {
          window.$gz.eventBus.$emit(
            "menu-enable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":new");
        } else {
          window.$gz.eventBus.$emit(
            "menu-disable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":new");
        }
      },
      deep: true
    }
  },
  async created() {
    const vm = this;
    try {
      await initForm(vm);

      vm.rights = window.$gz.role.getRights(window.$gz.type.Translation);
      vm.formState.readOnly = !vm.rights.change;
      window.$gz.eventBus.$on("menu-click", clickHandler);

      //id 0 means create or duplicate to new
      if (vm.$route.params.recordid != 0) {
        //is there already an obj from a prior operation?
        if (this.$route.params.obj) {
          //yes, no need to fetch it
          this.obj = this.$route.params.obj;
          vm.formState.loading = false; //here we handle it immediately
        } else {
          await vm.getDataFromApi(vm.$route.params.recordid);
        }
      } else {
        vm.formState.loading = false; //here we handle it immediately
      }
      //set initial form status
      window.$gz.form.setFormState({
        vm: vm,
        dirty: false,
        valid: true
      });

      generateMenu(vm);
    } catch (error) {
      window.$gz.errorHandler.handleFormError(error, vm);
    } finally {
      vm.formState.ready = true;
    }
  },
  async beforeRouteLeave(to, from, next) {
    if (!this.formState.dirty || JUST_DELETED) {
      next();
      return;
    }
    if ((await window.$gz.dialog.confirmLeaveUnsaved()) === true) {
      next();
    } else {
      next(false);
    }
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    doReplace() {
      let changesMade = false;
      if (this.find && this.replace) {
        for (let i = 0; i < this.obj.translationItems.length; i++) {
          if (
            !changesMade &&
            this.obj.translationItems[i].display.includes(this.find)
          ) {
            changesMade = true;
          }
          this.obj.translationItems[i].display = this.obj.translationItems[
            i
          ].display
            .split(this.find)
            .join(this.replace);
        }

        if (changesMade == true) {
          window.$gz.form.setFormState({
            vm: this,
            dirty: true
          });
        }
      }
      this.replaceDialog = false;
    },
    saveItem() {
      if (this.editText == null || this.editText == "") {
        return;
      }
      this.editItem.display = this.editText;
      window.$gz.form.setFormState({
        vm: this,
        dirty: true
      });
    },
    openEditDialog(item) {
      this.editItem = item;
      this.editText = item.display;
    },
    canDuplicate: function() {
      return (
        this.formState.valid && !this.formState.dirty && this.rights.change
      );
    },
    sockTypes: function() {
      return window.$gz.type;
    },
    form() {
      return window.$gz.form;
    },
    fieldValueChanged(ref) {
      if (
        this.formState.ready &&
        !this.formState.loading &&
        !this.formState.readOnly
      ) {
        window.$gz.form.fieldValueChanged(this, ref);
      }
    },
    async getDataFromApi(recordId) {
      const vm = this;
      vm.formState.loading = true;

      if (!recordId) {
        throw new Error(FORM_KEY + "::getDataFromApi -> Missing recordID!");
      }

      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.get(API_BASE_URL + recordId);
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
          vm.formState.loading = false;
        } else {
          vm.obj = res.data;
          generateMenu(vm);
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false,
            readOnly: !vm.rights.change || res.data.stock == true
          });
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, vm);
        vm.formState.loading = false;
      }
    },
    async submit() {
      const vm = this;
      if (vm.canSave == false) {
        return;
      }

      try {
        vm.formState.loading = true;
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.upsert(API_BASE_URL, vm.obj);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data.id) {
            //POST
            vm.obj = res.data;
            //Change URL to new record
            this.$router.replace({
              name: "adm-translation",
              params: {
                recordid: res.data.id,
                obj: res.data //Pass data object to new form
              }
            });
          } else {
            //PUT
            vm.obj.concurrency = res.data.concurrency;
            //Update local copy of translations if that's the same one in use
            if (vm.editingActiveTranslation) {
              await window.$gz.translation.updateCache(vm.obj);
            }
          }
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        vm.formState.loading = false;
      }
    },
    async remove() {
      try {
        const dialogResult = await window.$gz.dialog.confirmDelete();
        if (dialogResult != true) {
          return;
        }
        this.formState.loading = true;
        if (this.$route.params.recordid == 0) {
          JUST_DELETED = true;
          this.$router.go(-1);
        } else {
          window.$gz.form.deleteAllErrorBoxErrors(this);
          const res = await window.$gz.api.remove(
            API_BASE_URL + this.$route.params.recordid
          );
          if (res.error) {
            this.formState.serverError = res.error;
            window.$gz.form.setErrorBoxErrors(this);
          } else {
            JUST_DELETED = true;
            this.$router.go(-1);
          }
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, this);
      } finally {
        this.formState.loading = false;
      }
    },
    async duplicate() {
      const vm = this;
      if (!vm.canDuplicate || vm.$route.params.recordid == 0) {
        return;
      }
      vm.formState.loading = true;
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        vm.duplicating = true;
        const res = await window.$gz.api.upsert(
          API_BASE_URL + "duplicate/" + vm.$route.params.recordid
        );
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          this.$router.push({
            name: "adm-translation",
            params: {
              recordid: res.data.id,
              obj: res.data
            }
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        vm.formState.loading = false;
        vm.duplicating = false;
      }
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "save":
        m.vm.submit();
        break;
      case "replace":
        m.vm.replaceDialog = true;
        break;
      case "export":
        //ignore download link let it go
        break;
      case "delete":
        m.vm.remove();
        break;
      case "new":
        m.vm.$router.push({
          name: "adm-translation",
          params: { recordid: 0 }
        });
        break;
      case "duplicate":
        m.vm.duplicate();
        break;

      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: false,
    readOnly: vm.formState.readOnly,
    icon: "$sockiLanguage",
    title: "Translation",
    helpUrl: "adm-translations",
    formData: {
      sockType: window.$gz.type.Translation,
      recordId: vm.$route.params.recordid,
      recordName: vm.obj.name
    },
    menuItems: []
  };
  if (vm.rights.change && vm.obj.stock != true) {
    menuOptions.menuItems.push({
      title: "Save",
      icon: "$sockiSave",
      surface: true,
      key: FORM_KEY + ":save",
      vm: vm
    });
  }

  if (vm.rights.change && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Duplicate",
      icon: "$sockiClone",
      key: FORM_KEY + ":duplicate",
      vm: vm
    });
  }
  menuOptions.menuItems.push({ divider: true, inset: false });
  if (vm.rights.change && vm.obj.stock != true) {
    menuOptions.menuItems.push({
      title: "FindAndReplace",
      icon: null,
      key: FORM_KEY + ":replace",
      vm: vm
    });
  }

  //EXPORT
  if (vm.$route.params.recordid != 0) {
    const href = window.$gz.api.genericDownloadUrl(
      "translation/download/" + vm.$route.params.recordid
    );
    menuOptions.menuItems.push({
      title: "Export",
      icon: "$sockiFileDownload",
      href: href,
      target: "_blank",
      key: FORM_KEY + ":export",
      vm: vm
    });
  }

  if (
    vm.rights.delete &&
    vm.$route.params.recordid != 0 &&
    vm.obj.stock != true
  ) {
    menuOptions.menuItems.push({
      title: "Delete",
      icon: "$sockiTrashAlt",
      surface: false,
      key: FORM_KEY + ":delete",
      vm: vm
    });
  }
  menuOptions.menuItems.push({ divider: true, inset: false });

  window.$gz.eventBus.$emit("menu-change", menuOptions);
}

let JUST_DELETED = false;

/////////////////////////////////
//
//
async function initForm(vm) {
  await fetchTranslatedText();
  await setEditingActiveTranslation(vm);
}

//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations([
    "Translation",
    "Name",
    "ReadOnly",
    "TranslationKey",
    "TranslationDisplayText",
    "FindAndReplace",
    "Find",
    "Replace",
    "GlobalCJKIndex",
    "GlobalCJKIndexDescription"
  ]);
}

//////////////////////////////////////////////////////////
//
//
async function setEditingActiveTranslation(vm) {
  if (vm.$route.params.recordid != 0) {
    const res = await window.$gz.api.get(
      "user-option/" + vm.$store.state.userId
    );
    vm.editingActiveTranslation =
      res.data.translationId == vm.$route.params.recordid;
  }
}
</script>
